set talk off


#define ofs				1
#define depth			4

#define inc				(1 / 10)

#define linecolor1		'R'
#define linecolor2		'B'
#define linecolor3		'G'

#define dTheta			11
#define dPhi			7

theta 	= 0
phi		= 0
D		= 500
cx		= 15
cy		= 15
rho		= 100

#define tlb		1,1,1
#define blb		1,1,-1
#define trb		1,-1,1
#define	brb		1,-1,-1
#define tlf		-1,1,1
#define blf		-1,1,-1
#define trf		-1,-1,1
#define brf		-1,-1,-1

*
*	*----*\
*	|\*----*
*	| |  | |
*   *-|--*\|
*    \*----*
*
define window first at 5,5 size 25,30 system title "Draw Box"
define window second at 5,5 size 25,30 system title "Draw Box"

first = .t.
do while .t.

	k=inkey()
	if k#0
		exit
	endif
	
	if first
		activate window first bottom
	else
		activate window second bottom
	endif
	first = not first
	clear
	
	do drawline with spherical(tlb,'x'),spherical(tlb,'y'),spherical(blb,'x'),spherical(blb,'y'), linecolor1, 0.1, 0.1, .T.
	do drawline with spherical(blb,'x'),spherical(blb,'y'),spherical(brb,'x'),spherical(brb,'y'), linecolor3
	do drawline with spherical(brb,'x'),spherical(brb,'y'),spherical(trb,'x'),spherical(trb,'y'), linecolor2
	do drawline with spherical(trb,'x'),spherical(trb,'y'),spherical(tlb,'x'),spherical(tlb,'y'), linecolor2

	do drawline with spherical(tlf,'x'),spherical(tlf,'y'),spherical(blf,'x'),spherical(blf,'y'), linecolor2
	do drawline with spherical(blf,'x'),spherical(blf,'y'),spherical(brf,'x'),spherical(brf,'y'), linecolor2
	do drawline with spherical(brf,'x'),spherical(brf,'y'),spherical(trf,'x'),spherical(trf,'y'), linecolor2
	do drawline with spherical(trf,'x'),spherical(trf,'y'),spherical(tlf,'x'),spherical(tlf,'y'), linecolor2

	do drawline with spherical(tlb,'x'),spherical(tlb,'y'),spherical(tlf,'x'),spherical(tlf,'y'), linecolor2
	do drawline with spherical(blb,'x'),spherical(blb,'y'),spherical(blf,'x'),spherical(blf,'y'), linecolor2
	do drawline with spherical(trb,'x'),spherical(trb,'y'),spherical(trf,'x'),spherical(trf,'y'), linecolor2
	do drawline with spherical(brb,'x'),spherical(brb,'y'),spherical(brf,'x'),spherical(brf,'y'), linecolor2
	
	@ 1,1 say "Theta "+str(theta%360,3)
	@ 2,1 say "Phi   "+str(phi%360,3)
	@ 1,13 say "Any Key to Exit"
	
	theta = theta + dTheta
	phi = phi + dPhi

enddo

clear window


return


procedure spherical
parameter x,y,z, type

	s1 = sin(dtor(theta))
	c1 = cos(dtor(theta))
	s2 = sin(dtor(phi))
	c2 = cos(dtor(phi))
	
	xe = -x*s1 + y*c1
	ye = -x*c1*c2 - y*s1*c2 + z*s2
	ze = -x*c1*s2 - y*s1*s2 - z*c2 + rho
	
	sx = cx+(d*(xe/ze))
	sy = cy-(d*(ye/ze))
	
	return eval('s'+type)
	
